import _asyncToGenerator from '@babel/runtime/helpers/asyncToGenerator';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _regeneratorRuntime from '@babel/runtime/regenerator';
import SparkMD5$1 from 'spark-md5';
import _createClass from '@babel/runtime/helpers/createClass';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _assertThisInitialized from '@babel/runtime/helpers/assertThisInitialized';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import Dexie from 'dexie';
import _typeof from '@babel/runtime/helpers/typeof';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var FileCacheDB = /*#__PURE__*/function (_Dexie) {
  _inherits(FileCacheDB, _Dexie);
  var _super = _createSuper(FileCacheDB);
  // 'friends' is added by dexie when declaring the stores()
  // We just tell the typing system this is the case

  function FileCacheDB() {
    var _this;
    _classCallCheck(this, FileCacheDB);
    _this = _super.call(this, "fileDataBase");
    _defineProperty(_assertThisInitialized(_this), "files", void 0);
    _this.version(2).stores({
      files: "++id, spaceName" // Primary key and indexed props
    });
    return _this;
  }
  return _createClass(FileCacheDB);
}(Dexie);
var db = new FileCacheDB();

var workerFn = function workerFn() {
  self.onmessage = function (event) {
    (function (factory) {
      if ((typeof exports === "undefined" ? "undefined" : _typeof(exports)) === "object") {
        module.exports = factory();
      } else if (typeof define === "function" && define.amd) {
        define(factory);
      } else {
        var glob;
        try {
          glob = window;
        } catch (e) {
          glob = self;
        }
        glob.SparkMD5 = factory();
      }
    })(function (undefined$1) {

      var hex_chr = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"];
      function md5cycle(x, k) {
        var a = x[0],
          b = x[1],
          c = x[2],
          d = x[3];
        a += (b & c | ~b & d) + k[0] - 680876936 | 0;
        a = (a << 7 | a >>> 25) + b | 0;
        d += (a & b | ~a & c) + k[1] - 389564586 | 0;
        d = (d << 12 | d >>> 20) + a | 0;
        c += (d & a | ~d & b) + k[2] + 606105819 | 0;
        c = (c << 17 | c >>> 15) + d | 0;
        b += (c & d | ~c & a) + k[3] - 1044525330 | 0;
        b = (b << 22 | b >>> 10) + c | 0;
        a += (b & c | ~b & d) + k[4] - 176418897 | 0;
        a = (a << 7 | a >>> 25) + b | 0;
        d += (a & b | ~a & c) + k[5] + 1200080426 | 0;
        d = (d << 12 | d >>> 20) + a | 0;
        c += (d & a | ~d & b) + k[6] - 1473231341 | 0;
        c = (c << 17 | c >>> 15) + d | 0;
        b += (c & d | ~c & a) + k[7] - 45705983 | 0;
        b = (b << 22 | b >>> 10) + c | 0;
        a += (b & c | ~b & d) + k[8] + 1770035416 | 0;
        a = (a << 7 | a >>> 25) + b | 0;
        d += (a & b | ~a & c) + k[9] - 1958414417 | 0;
        d = (d << 12 | d >>> 20) + a | 0;
        c += (d & a | ~d & b) + k[10] - 42063 | 0;
        c = (c << 17 | c >>> 15) + d | 0;
        b += (c & d | ~c & a) + k[11] - 1990404162 | 0;
        b = (b << 22 | b >>> 10) + c | 0;
        a += (b & c | ~b & d) + k[12] + 1804603682 | 0;
        a = (a << 7 | a >>> 25) + b | 0;
        d += (a & b | ~a & c) + k[13] - 40341101 | 0;
        d = (d << 12 | d >>> 20) + a | 0;
        c += (d & a | ~d & b) + k[14] - 1502002290 | 0;
        c = (c << 17 | c >>> 15) + d | 0;
        b += (c & d | ~c & a) + k[15] + 1236535329 | 0;
        b = (b << 22 | b >>> 10) + c | 0;
        a += (b & d | c & ~d) + k[1] - 165796510 | 0;
        a = (a << 5 | a >>> 27) + b | 0;
        d += (a & c | b & ~c) + k[6] - 1069501632 | 0;
        d = (d << 9 | d >>> 23) + a | 0;
        c += (d & b | a & ~b) + k[11] + 643717713 | 0;
        c = (c << 14 | c >>> 18) + d | 0;
        b += (c & a | d & ~a) + k[0] - 373897302 | 0;
        b = (b << 20 | b >>> 12) + c | 0;
        a += (b & d | c & ~d) + k[5] - 701558691 | 0;
        a = (a << 5 | a >>> 27) + b | 0;
        d += (a & c | b & ~c) + k[10] + 38016083 | 0;
        d = (d << 9 | d >>> 23) + a | 0;
        c += (d & b | a & ~b) + k[15] - 660478335 | 0;
        c = (c << 14 | c >>> 18) + d | 0;
        b += (c & a | d & ~a) + k[4] - 405537848 | 0;
        b = (b << 20 | b >>> 12) + c | 0;
        a += (b & d | c & ~d) + k[9] + 568446438 | 0;
        a = (a << 5 | a >>> 27) + b | 0;
        d += (a & c | b & ~c) + k[14] - 1019803690 | 0;
        d = (d << 9 | d >>> 23) + a | 0;
        c += (d & b | a & ~b) + k[3] - 187363961 | 0;
        c = (c << 14 | c >>> 18) + d | 0;
        b += (c & a | d & ~a) + k[8] + 1163531501 | 0;
        b = (b << 20 | b >>> 12) + c | 0;
        a += (b & d | c & ~d) + k[13] - 1444681467 | 0;
        a = (a << 5 | a >>> 27) + b | 0;
        d += (a & c | b & ~c) + k[2] - 51403784 | 0;
        d = (d << 9 | d >>> 23) + a | 0;
        c += (d & b | a & ~b) + k[7] + 1735328473 | 0;
        c = (c << 14 | c >>> 18) + d | 0;
        b += (c & a | d & ~a) + k[12] - 1926607734 | 0;
        b = (b << 20 | b >>> 12) + c | 0;
        a += (b ^ c ^ d) + k[5] - 378558 | 0;
        a = (a << 4 | a >>> 28) + b | 0;
        d += (a ^ b ^ c) + k[8] - 2022574463 | 0;
        d = (d << 11 | d >>> 21) + a | 0;
        c += (d ^ a ^ b) + k[11] + 1839030562 | 0;
        c = (c << 16 | c >>> 16) + d | 0;
        b += (c ^ d ^ a) + k[14] - 35309556 | 0;
        b = (b << 23 | b >>> 9) + c | 0;
        a += (b ^ c ^ d) + k[1] - 1530992060 | 0;
        a = (a << 4 | a >>> 28) + b | 0;
        d += (a ^ b ^ c) + k[4] + 1272893353 | 0;
        d = (d << 11 | d >>> 21) + a | 0;
        c += (d ^ a ^ b) + k[7] - 155497632 | 0;
        c = (c << 16 | c >>> 16) + d | 0;
        b += (c ^ d ^ a) + k[10] - 1094730640 | 0;
        b = (b << 23 | b >>> 9) + c | 0;
        a += (b ^ c ^ d) + k[13] + 681279174 | 0;
        a = (a << 4 | a >>> 28) + b | 0;
        d += (a ^ b ^ c) + k[0] - 358537222 | 0;
        d = (d << 11 | d >>> 21) + a | 0;
        c += (d ^ a ^ b) + k[3] - 722521979 | 0;
        c = (c << 16 | c >>> 16) + d | 0;
        b += (c ^ d ^ a) + k[6] + 76029189 | 0;
        b = (b << 23 | b >>> 9) + c | 0;
        a += (b ^ c ^ d) + k[9] - 640364487 | 0;
        a = (a << 4 | a >>> 28) + b | 0;
        d += (a ^ b ^ c) + k[12] - 421815835 | 0;
        d = (d << 11 | d >>> 21) + a | 0;
        c += (d ^ a ^ b) + k[15] + 530742520 | 0;
        c = (c << 16 | c >>> 16) + d | 0;
        b += (c ^ d ^ a) + k[2] - 995338651 | 0;
        b = (b << 23 | b >>> 9) + c | 0;
        a += (c ^ (b | ~d)) + k[0] - 198630844 | 0;
        a = (a << 6 | a >>> 26) + b | 0;
        d += (b ^ (a | ~c)) + k[7] + 1126891415 | 0;
        d = (d << 10 | d >>> 22) + a | 0;
        c += (a ^ (d | ~b)) + k[14] - 1416354905 | 0;
        c = (c << 15 | c >>> 17) + d | 0;
        b += (d ^ (c | ~a)) + k[5] - 57434055 | 0;
        b = (b << 21 | b >>> 11) + c | 0;
        a += (c ^ (b | ~d)) + k[12] + 1700485571 | 0;
        a = (a << 6 | a >>> 26) + b | 0;
        d += (b ^ (a | ~c)) + k[3] - 1894986606 | 0;
        d = (d << 10 | d >>> 22) + a | 0;
        c += (a ^ (d | ~b)) + k[10] - 1051523 | 0;
        c = (c << 15 | c >>> 17) + d | 0;
        b += (d ^ (c | ~a)) + k[1] - 2054922799 | 0;
        b = (b << 21 | b >>> 11) + c | 0;
        a += (c ^ (b | ~d)) + k[8] + 1873313359 | 0;
        a = (a << 6 | a >>> 26) + b | 0;
        d += (b ^ (a | ~c)) + k[15] - 30611744 | 0;
        d = (d << 10 | d >>> 22) + a | 0;
        c += (a ^ (d | ~b)) + k[6] - 1560198380 | 0;
        c = (c << 15 | c >>> 17) + d | 0;
        b += (d ^ (c | ~a)) + k[13] + 1309151649 | 0;
        b = (b << 21 | b >>> 11) + c | 0;
        a += (c ^ (b | ~d)) + k[4] - 145523070 | 0;
        a = (a << 6 | a >>> 26) + b | 0;
        d += (b ^ (a | ~c)) + k[11] - 1120210379 | 0;
        d = (d << 10 | d >>> 22) + a | 0;
        c += (a ^ (d | ~b)) + k[2] + 718787259 | 0;
        c = (c << 15 | c >>> 17) + d | 0;
        b += (d ^ (c | ~a)) + k[9] - 343485551 | 0;
        b = (b << 21 | b >>> 11) + c | 0;
        x[0] = a + x[0] | 0;
        x[1] = b + x[1] | 0;
        x[2] = c + x[2] | 0;
        x[3] = d + x[3] | 0;
      }
      function md5blk(s) {
        var md5blks = [],
          i;
        for (i = 0; i < 64; i += 4) {
          md5blks[i >> 2] = s.charCodeAt(i) + (s.charCodeAt(i + 1) << 8) + (s.charCodeAt(i + 2) << 16) + (s.charCodeAt(i + 3) << 24);
        }
        return md5blks;
      }
      function md5blk_array(a) {
        var md5blks = [],
          i;
        for (i = 0; i < 64; i += 4) {
          md5blks[i >> 2] = a[i] + (a[i + 1] << 8) + (a[i + 2] << 16) + (a[i + 3] << 24);
        }
        return md5blks;
      }
      function md51(s) {
        var n = s.length,
          state = [1732584193, -271733879, -1732584194, 271733878],
          i,
          length,
          tail,
          tmp,
          lo,
          hi;
        for (i = 64; i <= n; i += 64) {
          md5cycle(state, md5blk(s.substring(i - 64, i)));
        }
        s = s.substring(i - 64);
        length = s.length;
        tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        for (i = 0; i < length; i += 1) {
          tail[i >> 2] |= s.charCodeAt(i) << (i % 4 << 3);
        }
        tail[i >> 2] |= 128 << (i % 4 << 3);
        if (i > 55) {
          md5cycle(state, tail);
          for (i = 0; i < 16; i += 1) {
            tail[i] = 0;
          }
        }
        tmp = n * 8;
        tmp = tmp.toString(16).match(/(.*?)(.{0,8})$/);
        lo = parseInt(tmp[2], 16);
        hi = parseInt(tmp[1], 16) || 0;
        tail[14] = lo;
        tail[15] = hi;
        md5cycle(state, tail);
        return state;
      }
      function md51_array(a) {
        var n = a.length,
          state = [1732584193, -271733879, -1732584194, 271733878],
          i,
          length,
          tail,
          tmp,
          lo,
          hi;
        for (i = 64; i <= n; i += 64) {
          md5cycle(state, md5blk_array(a.subarray(i - 64, i)));
        }
        a = i - 64 < n ? a.subarray(i - 64) : new Uint8Array(0);
        length = a.length;
        tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        for (i = 0; i < length; i += 1) {
          tail[i >> 2] |= a[i] << (i % 4 << 3);
        }
        tail[i >> 2] |= 128 << (i % 4 << 3);
        if (i > 55) {
          md5cycle(state, tail);
          for (i = 0; i < 16; i += 1) {
            tail[i] = 0;
          }
        }
        tmp = n * 8;
        tmp = tmp.toString(16).match(/(.*?)(.{0,8})$/);
        lo = parseInt(tmp[2], 16);
        hi = parseInt(tmp[1], 16) || 0;
        tail[14] = lo;
        tail[15] = hi;
        md5cycle(state, tail);
        return state;
      }
      function rhex(n) {
        var s = "",
          j;
        for (j = 0; j < 4; j += 1) {
          s += hex_chr[n >> j * 8 + 4 & 15] + hex_chr[n >> j * 8 & 15];
        }
        return s;
      }
      function hex(x) {
        var i;
        for (i = 0; i < x.length; i += 1) {
          x[i] = rhex(x[i]);
        }
        return x.join("");
      }
      if (hex(md51("hello")) !== "5d41402abc4b2a76b9719d911017c592") ;
      if (typeof ArrayBuffer !== "undefined" && !ArrayBuffer.prototype.slice) {
        (function () {
          function clamp(val, length) {
            val = val | 0 || 0;
            if (val < 0) {
              return Math.max(val + length, 0);
            }
            return Math.min(val, length);
          }
          ArrayBuffer.prototype.slice = function (from, to) {
            var length = this.byteLength,
              begin = clamp(from, length),
              end = length,
              num,
              target,
              targetArray,
              sourceArray;
            if (to !== undefined$1) {
              end = clamp(to, length);
            }
            if (begin > end) {
              return new ArrayBuffer(0);
            }
            num = end - begin;
            target = new ArrayBuffer(num);
            targetArray = new Uint8Array(target);
            sourceArray = new Uint8Array(this, begin, num);
            targetArray.set(sourceArray);
            return target;
          };
        })();
      }
      function toUtf8(str) {
        if (/[\u0080-\uFFFF]/.test(str)) {
          str = unescape(encodeURIComponent(str));
        }
        return str;
      }
      function utf8Str2ArrayBuffer(str, returnUInt8Array) {
        var length = str.length,
          buff = new ArrayBuffer(length),
          arr = new Uint8Array(buff),
          i;
        for (i = 0; i < length; i += 1) {
          arr[i] = str.charCodeAt(i);
        }
        return returnUInt8Array ? arr : buff;
      }
      function arrayBuffer2Utf8Str(buff) {
        return String.fromCharCode.apply(null, new Uint8Array(buff));
      }
      function concatenateArrayBuffers(first, second, returnUInt8Array) {
        var result = new Uint8Array(first.byteLength + second.byteLength);
        result.set(new Uint8Array(first));
        result.set(new Uint8Array(second), first.byteLength);
        return returnUInt8Array ? result : result.buffer;
      }
      function hexToBinaryString(hex) {
        var bytes = [],
          length = hex.length,
          x;
        for (x = 0; x < length - 1; x += 2) {
          bytes.push(parseInt(hex.substr(x, 2), 16));
        }
        return String.fromCharCode.apply(String, bytes);
      }
      function SparkMD5() {
        this.reset();
      }
      SparkMD5.prototype.append = function (str) {
        this.appendBinary(toUtf8(str));
        return this;
      };
      SparkMD5.prototype.appendBinary = function (contents) {
        this._buff += contents;
        this._length += contents.length;
        var length = this._buff.length,
          i;
        for (i = 64; i <= length; i += 64) {
          md5cycle(this._hash, md5blk(this._buff.substring(i - 64, i)));
        }
        this._buff = this._buff.substring(i - 64);
        return this;
      };
      SparkMD5.prototype.end = function (raw) {
        var buff = this._buff,
          length = buff.length,
          i,
          tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
          ret;
        for (i = 0; i < length; i += 1) {
          tail[i >> 2] |= buff.charCodeAt(i) << (i % 4 << 3);
        }
        this._finish(tail, length);
        ret = hex(this._hash);
        if (raw) {
          ret = hexToBinaryString(ret);
        }
        this.reset();
        return ret;
      };
      SparkMD5.prototype.reset = function () {
        this._buff = "";
        this._length = 0;
        this._hash = [1732584193, -271733879, -1732584194, 271733878];
        return this;
      };
      SparkMD5.prototype.getState = function () {
        return {
          buff: this._buff,
          length: this._length,
          hash: this._hash.slice()
        };
      };
      SparkMD5.prototype.setState = function (state) {
        this._buff = state.buff;
        this._length = state.length;
        this._hash = state.hash;
        return this;
      };
      SparkMD5.prototype.destroy = function () {
        delete this._hash;
        delete this._buff;
        delete this._length;
      };
      SparkMD5.prototype._finish = function (tail, length) {
        var i = length,
          tmp,
          lo,
          hi;
        tail[i >> 2] |= 128 << (i % 4 << 3);
        if (i > 55) {
          md5cycle(this._hash, tail);
          for (i = 0; i < 16; i += 1) {
            tail[i] = 0;
          }
        }
        tmp = this._length * 8;
        tmp = tmp.toString(16).match(/(.*?)(.{0,8})$/);
        lo = parseInt(tmp[2], 16);
        hi = parseInt(tmp[1], 16) || 0;
        tail[14] = lo;
        tail[15] = hi;
        md5cycle(this._hash, tail);
      };
      SparkMD5.hash = function (str, raw) {
        return SparkMD5.hashBinary(toUtf8(str), raw);
      };
      SparkMD5.hashBinary = function (content, raw) {
        var hash = md51(content),
          ret = hex(hash);
        return raw ? hexToBinaryString(ret) : ret;
      };
      SparkMD5.ArrayBuffer = function () {
        this.reset();
      };
      SparkMD5.ArrayBuffer.prototype.append = function (arr) {
        var buff = concatenateArrayBuffers(this._buff.buffer, arr, true),
          length = buff.length,
          i;
        this._length += arr.byteLength;
        for (i = 64; i <= length; i += 64) {
          md5cycle(this._hash, md5blk_array(buff.subarray(i - 64, i)));
        }
        this._buff = i - 64 < length ? new Uint8Array(buff.buffer.slice(i - 64)) : new Uint8Array(0);
        return this;
      };
      SparkMD5.ArrayBuffer.prototype.end = function (raw) {
        var buff = this._buff,
          length = buff.length,
          tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
          i,
          ret;
        for (i = 0; i < length; i += 1) {
          tail[i >> 2] |= buff[i] << (i % 4 << 3);
        }
        this._finish(tail, length);
        ret = hex(this._hash);
        if (raw) {
          ret = hexToBinaryString(ret);
        }
        this.reset();
        return ret;
      };
      SparkMD5.ArrayBuffer.prototype.reset = function () {
        this._buff = new Uint8Array(0);
        this._length = 0;
        this._hash = [1732584193, -271733879, -1732584194, 271733878];
        return this;
      };
      SparkMD5.ArrayBuffer.prototype.getState = function () {
        var state = SparkMD5.prototype.getState.call(this);
        state.buff = arrayBuffer2Utf8Str(state.buff);
        return state;
      };
      SparkMD5.ArrayBuffer.prototype.setState = function (state) {
        state.buff = utf8Str2ArrayBuffer(state.buff, true);
        return SparkMD5.prototype.setState.call(this, state);
      };
      SparkMD5.ArrayBuffer.prototype.destroy = SparkMD5.prototype.destroy;
      SparkMD5.ArrayBuffer.prototype._finish = SparkMD5.prototype._finish;
      SparkMD5.ArrayBuffer.hash = function (arr, raw) {
        var hash = md51_array(new Uint8Array(arr)),
          ret = hex(hash);
        return raw ? hexToBinaryString(ret) : ret;
      };
      return SparkMD5;
    });

    // data: { result: boolean; index: number; data: any }
    var data = event.data;
    var text = data.data;
    try {
      var hash = SparkMD5.hash(text);
      postMessage({
        result: true,
        data: hash,
        index: data.index,
        task: data.task
      });
    } catch (error) {
      postMessage({
        result: false,
        data: error,
        index: data.index,
        task: data.task
      });
    }
  };
};

var isEqualArray = function isEqualArray(array1, array2) {
  if (Array.isArray(array1) && Array.isArray(array2) && array1.length === array2.length) {
    return array1.every(function (item, index) {
      return item === array2[index];
    });
  } else {
    return false;
  }
};
var createMultithread = function createMultithread(url, count) {
  return new Array(count).fill(true).map(function () {
    var worker = new Worker(url);
    return worker;
  });
};
var promiseHandlers = {};
var prevThreads = [];
var createSetTaskToMultithreading = function createSetTaskToMultithreading(threads, task) {
  var index = 0;
  var threadIndex = 0;
  var onmessage = function onmessage(event) {
    var data = event.data;
    if (data.result) {
      promiseHandlers[data.task][data.index].resolve(data.data);
    } else {
      promiseHandlers[data.task][data.index].reject(data.data);
    }
  };
  if (!isEqualArray(threads, prevThreads)) {
    threads.forEach(function (thread) {
      thread.addEventListener("message", onmessage);
    });
    prevThreads = threads;
  }
  return function (taskData) {
    var _resolve = function _resolve() {},
      _reject = function _reject() {};
    var promise = new Promise(function (resolve, reject) {
      _resolve = resolve;
      _reject = reject;
      var numberOfThreads = threads.length;
      threads[threadIndex].postMessage({
        data: taskData,
        index: index,
        task: task
      });
      if (threadIndex >= numberOfThreads - 1) {
        threadIndex = 0;
      } else {
        threadIndex++;
      }
    });
    if (!promiseHandlers[task]) {
      promiseHandlers[task] = [];
    }
    promiseHandlers[task][index] = {
      resolve: _resolve,
      reject: _reject
    };
    index++;
    return promise.finally(function () {
      promiseHandlers[task][index] = undefined;
    });
  };
};

var findFirstWaiting = function findFirstWaiting(uploadDataList) {
  var index = -1;
  var result = uploadDataList.some(function (u, _index) {
    index = _index;
    return u.status === "waiting";
  });
  return result ? uploadDataList[index] : undefined;
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var computeUploadDataList = function computeUploadDataList(list) {
  return list.filter(function (uploadData) {
    return uploadData.status !== "cancel";
  }).reverse();
};
var autoUpload = function autoUpload() {
  var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var _ref = arguments.length > 1 ? arguments[1] : undefined,
    idRef = _ref.idRef,
    upload = _ref.upload,
    updateUploadDataList = _ref.updateUploadDataList,
    computeProgress = _ref.computeProgress,
    update = _ref.update,
    resolve = _ref.resolve,
    reject = _ref.reject,
    sliceStartRef = _ref.sliceStartRef,
    length = _ref.length,
    index = _ref.index,
    numberOfChunks = _ref.numberOfChunks,
    chunks = _ref.chunks,
    customParamsRef = _ref.customParamsRef,
    retryCountLimit = _ref.retryCountLimit,
    _retryCountRef = _ref._retryCountRef,
    suspendedRef = _ref.suspendedRef,
    canceledRef = _ref.canceledRef,
    currentUploadListRef = _ref.currentUploadListRef,
    offlineStorage = _ref.offlineStorage,
    spaceName = _ref.spaceName,
    file = _ref.file,
    currentUpdateDataRef = _ref.currentUpdateDataRef,
    hashSum = _ref.hashSum,
    currentNumberOfRequestRef = _ref.currentNumberOfRequestRef,
    maxNumberOfRequest = _ref.maxNumberOfRequest;
  var isFirst = arguments.length > 2 ? arguments[2] : undefined;
  if (canceledRef.current) {
    return;
  }
  var handleFail = function handleFail(start) {
    if (_retryCountRef.current < retryCountLimit) {
      _retryCountRef.current++;
      autoUpload(start, {
        idRef: idRef,
        upload: upload,
        updateUploadDataList: updateUploadDataList,
        computeProgress: computeProgress,
        update: update,
        resolve: resolve,
        reject: reject,
        sliceStartRef: sliceStartRef,
        length: length,
        index: index,
        numberOfChunks: numberOfChunks,
        chunks: chunks,
        customParamsRef: customParamsRef,
        retryCountLimit: retryCountLimit,
        _retryCountRef: _retryCountRef,
        suspendedRef: suspendedRef,
        canceledRef: canceledRef,
        currentUploadListRef: currentUploadListRef,
        offlineStorage: offlineStorage,
        spaceName: spaceName,
        file: file,
        currentUpdateDataRef: currentUpdateDataRef,
        hashSum: hashSum,
        currentNumberOfRequestRef: currentNumberOfRequestRef,
        maxNumberOfRequest: maxNumberOfRequest
      });
    } else {
      sliceStartRef.current = start;
      updateUploadDataList(index, {
        status: "failure",
        progress: computeProgress(start)
      });
      update(computeUploadDataList(currentUploadListRef.current));
      reject(start);
    }
  };
  if (isFirst && currentNumberOfRequestRef.current < maxNumberOfRequest) {
    updateUploadDataList(index, {
      status: "uploading"
    });
    update(computeUploadDataList(currentUploadListRef.current));
    if (idRef.current !== undefined) {
      if (typeof idRef.current === "number") {
        db.files.update(idRef.current, {
          status: "uploading"
        });
      } else {
        idRef.current.then(function (id) {
          db.files.update(id, {
            status: "uploading"
          });
        });
      }
    }
    currentNumberOfRequestRef.current++;
  } else if (isFirst && currentNumberOfRequestRef.current >= maxNumberOfRequest) {
    updateUploadDataList(index, {
      status: "waiting"
    });
    update(computeUploadDataList(currentUploadListRef.current));
    if (idRef.current !== undefined) {
      if (typeof idRef.current === "number") {
        db.files.update(idRef.current, {
          status: "waiting"
        });
      } else {
        idRef.current.then(function (id) {
          db.files.update(id, {
            status: "waiting"
          });
        });
      }
    }
    return;
  }
  var nextStart = start + numberOfChunks;
  upload({
    chunks: chunks.slice(start, nextStart),
    start: start,
    end: nextStart - 1,
    size: length,
    hashSum: hashSum
  }, customParamsRef.current, function (data) {
    if (data) {
      updateUploadDataList(index, _objectSpread({}, data));
      update(computeUploadDataList(currentUploadListRef.current));
    }
  }).then(function (data) {
    if (suspendedRef.current || canceledRef.current) {
      return;
    }
    if (offlineStorage && idRef.current !== undefined) {
      if (typeof idRef.current === "number") {
        db.files.update(idRef.current, {
          status: "uploading",
          start: nextStart,
          end: nextStart + numberOfChunks,
          customParams: customParamsRef.current
        });
      } else {
        currentUpdateDataRef.current = {
          status: "uploading",
          start: nextStart,
          end: nextStart + numberOfChunks,
          customParams: customParamsRef.current
        };
      }
    }
    _retryCountRef.current = 0;
    customParamsRef.current = data;
    sliceStartRef.current = nextStart;
    updateUploadDataList(index, {
      status: "uploading",
      progress: computeProgress(nextStart)
    });
    update(computeUploadDataList(currentUploadListRef.current));
    // 完成
    if (nextStart >= length) {
      currentNumberOfRequestRef.current--;
      sliceStartRef.current = length;
      updateUploadDataList(index, {
        status: "completed",
        progress: computeProgress(length),
        result: data
      });
      update(computeUploadDataList(currentUploadListRef.current));
      resolve(true);
      if (idRef.current !== undefined) {
        if (typeof idRef.current === "number") {
          db.files.delete(idRef.current);
        } else {
          idRef.current.then(function (id) {
            db.files.delete(id);
          });
        }
      }
      var uploader = findFirstWaiting(currentUploadListRef.current);
      if (uploader) {
        uploader.resume();
      }
      return;
    }
    autoUpload(nextStart, {
      idRef: idRef,
      upload: upload,
      updateUploadDataList: updateUploadDataList,
      computeProgress: computeProgress,
      update: update,
      resolve: resolve,
      reject: reject,
      sliceStartRef: sliceStartRef,
      length: length,
      index: index,
      numberOfChunks: numberOfChunks,
      chunks: chunks,
      customParamsRef: customParamsRef,
      retryCountLimit: retryCountLimit,
      _retryCountRef: _retryCountRef,
      suspendedRef: suspendedRef,
      canceledRef: canceledRef,
      currentUploadListRef: currentUploadListRef,
      offlineStorage: offlineStorage,
      spaceName: spaceName,
      file: file,
      currentUpdateDataRef: currentUpdateDataRef,
      hashSum: hashSum,
      currentNumberOfRequestRef: currentNumberOfRequestRef,
      maxNumberOfRequest: maxNumberOfRequest
    });
  }).catch(function () {
    if (suspendedRef.current || canceledRef.current) {
      return;
    }
    if (offlineStorage && idRef.current !== undefined) {
      if (typeof idRef.current === "number") {
        db.files.update(idRef.current, {
          status: "failure",
          start: start,
          end: start + numberOfChunks
        });
      } else {
        currentUpdateDataRef.current = {
          status: "failure",
          start: start,
          end: start + numberOfChunks
        };
      }
    }
    handleFail(start);
  });
};
var createHiddenUploaderInputOrCreateDirectlyUpload = function createHiddenUploaderInputOrCreateDirectlyUpload(files) {
  var input;
  var handleChange;
  var scriptBlob = new Blob(["(".concat(workerFn, ")()")], {
    type: "application/javascript"
  });
  var blobURL = URL.createObjectURL(scriptBlob);
  return function (_ref2, currentUploadList, uploadPromiseResolve, uploadPromiseReject) {
    var slice = _ref2.slice,
      sliceSize = _ref2.sliceSize,
      minSlicedFileSize = _ref2.minSlicedFileSize,
      numberOfChunks = _ref2.numberOfChunks,
      retryCountLimit = _ref2.retryCountLimit,
      multiple = _ref2.multiple,
      accept = _ref2.accept,
      offlineStorage = _ref2.offlineStorage,
      spaceName = _ref2.spaceName,
      immediately = _ref2.immediately,
      sizeLimit = _ref2.sizeLimit,
      numberOfThreads = _ref2.numberOfThreads,
      openHash = _ref2.openHash,
      maxNumberOfRequest = _ref2.maxNumberOfRequest,
      upload = _ref2.upload,
      update = _ref2.update,
      checkHash = _ref2.checkHash;
    var workers = numberOfThreads > 1 ? createMultithread(blobURL, numberOfThreads) : [];
    // 可以作为input事件，也可直接传入文件
    handleChange = /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(event, directly) {
        var _files, currentNumberOfRequestRef, createUploaderData, progressList, updateUploadDataList, uploadList, results, errorsRecord;
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(directly || event.target)) {
                  _context3.next = 13;
                  break;
                }
                _files = directly ? Array.isArray(event) ? event : Array.from(event) : Array.from(event.target.files).filter(function (file) {
                  return sizeLimit ? file.size >= sizeLimit[0] && file.size <= sizeLimit[1] : true;
                });
                if (!_files) {
                  _context3.next = 13;
                  break;
                }
                currentNumberOfRequestRef = {
                  current: 0
                };
                createUploaderData = function createUploaderData(index) {
                  return {
                    status: "initialization",
                    progress: 0,
                    file: _files[index],
                    result: null,
                    createTimestamp: new Date().getTime(),
                    total: 0
                  };
                };
                progressList = _files.map(function (_, index) {
                  var uploader = createUploaderData(index);
                  // 每个文件都加在缓存文件后面，上一个文件会让currentUploadList.length + 1，要抵消掉
                  var indexInTotalList = currentUploadList.length;
                  currentUploadList[indexInTotalList] = uploader;
                  return uploader;
                });
                updateUploadDataList = function updateUploadDataList(index, progressData) {
                  Reflect.ownKeys(progressData).forEach(function (key) {
                    // @ts-ignore
                    progressList[index][key] = progressData[key];
                  });
                  return progressList;
                };
                update(computeUploadDataList(currentUploadList));
                uploadList = _files.map( /*#__PURE__*/function () {
                  var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(file, index) {
                    var spark, chunks, size, sliceStartRef, length, md5HexHash, computeProgress, sliceNumber, setTaskToMultithreading, multithreadTasksPromise, i, slicedFile, text, _text, _results, result, _retryCountRef, suspendedRef, canceledRef, customParamsRef, currentUploadListRef, currentUpdateDataRef;
                    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            spark = new SparkMD5$1();
                            chunks = [];
                            size = file.size;
                            sliceStartRef = {
                              current: 0
                            };
                            length = 0;
                            md5HexHash = "";
                            computeProgress = function computeProgress(start) {
                              return start / length;
                            }; // 未开启切片或文件大小小于切片限制则将整个文件作为第一个切片, chunk: [File]
                            if (!(slice && size >= minSlicedFileSize)) {
                              _context2.next = 51;
                              break;
                            }
                            sliceNumber = Math.ceil(size / sliceSize);
                            setTaskToMultithreading = createSetTaskToMultithreading(workers, "".concat(Math.random().toFixed(6), "-").concat(index));
                            multithreadTasksPromise = [];
                            i = 0;
                          case 12:
                            if (!(i < sliceNumber)) {
                              _context2.next = 30;
                              break;
                            }
                            slicedFile = file.slice(i * sliceSize, (i + 1) * sliceSize);
                            chunks.push(slicedFile);
                            if (!(openHash && numberOfThreads > 1)) {
                              _context2.next = 22;
                              break;
                            }
                            _context2.next = 18;
                            return slicedFile.text();
                          case 18:
                            text = _context2.sent;
                            multithreadTasksPromise[i] = setTaskToMultithreading(text);
                            _context2.next = 27;
                            break;
                          case 22:
                            if (!(openHash && numberOfThreads <= 1)) {
                              _context2.next = 27;
                              break;
                            }
                            _context2.next = 25;
                            return slicedFile.text();
                          case 25:
                            _text = _context2.sent;
                            spark.append(_text);
                          case 27:
                            i++;
                            _context2.next = 12;
                            break;
                          case 30:
                            length = chunks.length;
                            if (!openHash) {
                              _context2.next = 47;
                              break;
                            }
                            if (!(numberOfThreads > 1)) {
                              _context2.next = 39;
                              break;
                            }
                            _context2.next = 35;
                            return Promise.all(multithreadTasksPromise);
                          case 35:
                            _results = _context2.sent;
                            md5HexHash = _results.reduce(function (hash, result) {
                              return hash + result;
                            }, "");
                            _context2.next = 40;
                            break;
                          case 39:
                            md5HexHash = spark.end();
                          case 40:
                            if (!checkHash) {
                              _context2.next = 45;
                              break;
                            }
                            _context2.next = 43;
                            return checkHash(md5HexHash);
                          case 43:
                            result = _context2.sent;
                            if (result === true) {
                              sliceStartRef.current = length;
                              updateUploadDataList(index, {
                                status: "completed",
                                progress: 1
                              });
                              update(computeUploadDataList(currentUploadList));
                            } else if (typeof result === "number") {
                              sliceStartRef.current = result;
                              updateUploadDataList(index, {
                                status: "suspended",
                                progress: computeProgress(result)
                              });
                              update(computeUploadDataList(currentUploadList));
                            }
                          case 45:
                            _context2.next = 49;
                            break;
                          case 47:
                            updateUploadDataList(index, {
                              status: "suspended"
                            });
                            update(computeUploadDataList(currentUploadList));
                          case 49:
                            _context2.next = 53;
                            break;
                          case 51:
                            chunks.push(file);
                            length = chunks.length;
                          case 53:
                            updateUploadDataList(index, {
                              total: length
                            });
                            update(computeUploadDataList(currentUploadList));
                            _retryCountRef = {
                              current: 0
                            };
                            suspendedRef = {
                              current: false
                            };
                            canceledRef = {
                              current: false
                            };
                            customParamsRef = {
                              current: undefined
                            };
                            currentUploadListRef = {
                              current: currentUploadList
                            };
                            currentUpdateDataRef = {
                              current: undefined
                            };
                            return _context2.abrupt("return", new Promise( /*#__PURE__*/function () {
                              var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(resolve, reject) {
                                var idRef, pause, resume, remove;
                                return _regeneratorRuntime.wrap(function _callee$(_context) {
                                  while (1) {
                                    switch (_context.prev = _context.next) {
                                      case 0:
                                        idRef = {
                                          current: undefined
                                        };
                                        pause = function pause() {
                                          suspendedRef.current = true;
                                          if (progressList[index].status === "uploading") {
                                            currentNumberOfRequestRef.current--;
                                            updateUploadDataList(index, {
                                              status: "suspended",
                                              progress: computeProgress(sliceStartRef.current)
                                            });
                                            update(computeUploadDataList(currentUploadList));
                                            var uploader = findFirstWaiting(currentUploadListRef.current);
                                            if (uploader) {
                                              uploader.resume();
                                            }
                                            if (idRef.current !== undefined && typeof idRef.current !== "number") {
                                              idRef.current.then(function (id) {
                                                db.files.update(id, {
                                                  status: "suspended",
                                                  start: sliceStartRef.current,
                                                  end: sliceStartRef.current + numberOfChunks
                                                });
                                              });
                                            } else if (typeof idRef.current === "number") {
                                              db.files.update(idRef.current, {
                                                status: "suspended",
                                                start: sliceStartRef.current,
                                                end: sliceStartRef.current + numberOfChunks
                                              });
                                            }
                                          }
                                        };
                                        resume = function resume() {
                                          if (progressList[index].status === "initialization" || progressList[index].status === "suspended" || progressList[index].status === "failure") {
                                            _retryCountRef.current = 0;
                                            suspendedRef.current = false;
                                            var start = sliceStartRef.current;
                                            autoUpload(start, {
                                              idRef: idRef,
                                              upload: upload,
                                              updateUploadDataList: updateUploadDataList,
                                              computeProgress: computeProgress,
                                              update: update,
                                              resolve: resolve,
                                              reject: reject,
                                              sliceStartRef: sliceStartRef,
                                              length: length,
                                              index: index,
                                              numberOfChunks: numberOfChunks,
                                              chunks: chunks,
                                              customParamsRef: customParamsRef,
                                              retryCountLimit: retryCountLimit,
                                              _retryCountRef: _retryCountRef,
                                              suspendedRef: suspendedRef,
                                              canceledRef: canceledRef,
                                              currentUploadListRef: currentUploadListRef,
                                              offlineStorage: offlineStorage,
                                              spaceName: spaceName,
                                              file: _files[index],
                                              currentUpdateDataRef: currentUpdateDataRef,
                                              hashSum: md5HexHash,
                                              currentNumberOfRequestRef: currentNumberOfRequestRef,
                                              maxNumberOfRequest: maxNumberOfRequest
                                            }, true);
                                          }
                                        };
                                        remove = function remove() {
                                          currentNumberOfRequestRef.current--;
                                          canceledRef.current = true;
                                          updateUploadDataList(index, {
                                            status: "cancel"
                                          });
                                          update(computeUploadDataList(currentUploadList));
                                          if (idRef.current !== undefined && typeof idRef.current !== "number") {
                                            idRef.current.then(function (id) {
                                              db.files.delete(id);
                                            });
                                          } else if (typeof idRef.current === "number") {
                                            db.files.delete(idRef.current);
                                          }
                                          resolve(true);
                                        };
                                        updateUploadDataList(index, {
                                          pause: pause,
                                          resume: resume,
                                          remove: remove
                                        });
                                        if (offlineStorage && sliceStartRef.current < length) {
                                          idRef.current = db.files.add({
                                            file: _files[index],
                                            chunks: chunks,
                                            status: "suspended",
                                            start: 0,
                                            end: numberOfChunks,
                                            customParams: customParamsRef.current,
                                            spaceName: spaceName || "",
                                            hashSum: md5HexHash,
                                            createTimestamp: progressList[index].createTimestamp
                                          });
                                          idRef.current.then(function (id) {
                                            if (currentUpdateDataRef.current) {
                                              db.files.update(id, currentUpdateDataRef.current);
                                              idRef.current = id;
                                            }
                                          });
                                        }
                                        if (immediately && sliceStartRef.current < length) {
                                          resume();
                                        }
                                      case 7:
                                      case "end":
                                        return _context.stop();
                                    }
                                  }
                                }, _callee);
                              }));
                              return function (_x5, _x6) {
                                return _ref5.apply(this, arguments);
                              };
                            }()));
                          case 62:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));
                  return function (_x3, _x4) {
                    return _ref4.apply(this, arguments);
                  };
                }());
                _context3.next = 11;
                return Promise.all(uploadList);
              case 11:
                results = _context3.sent;
                if (results.every(function (result) {
                  return result === true;
                })) {
                  uploadPromiseResolve();
                } else {
                  errorsRecord = results.reduce(function (r, result, index) {
                    if (result !== true) {
                      r.push(index);
                    }
                    return r;
                  }, []).map(function (index) {
                    return _files[index];
                  });
                  uploadPromiseReject(errorsRecord);
                }
              case 13:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));
      return function handleChange(_x, _x2) {
        return _ref3.apply(this, arguments);
      };
    }();
    if (files) {
      handleChange(files, true);
    } else {
      if (input) {
        input.value = "";
        return input;
      }
      input = document.createElement("input");
      input.style.display = "none";
      input.type = "file";
      input.multiple = multiple ? true : false;
      input.accept = accept;
      input.addEventListener("change", function (event) {
        return handleChange(event);
      });
      return input;
    }
  };
};
var include = function include(parent, child) {
  var children = parent.children;
  var length = children.length;
  for (var i = length - 1; i >= 0; i--) {
    var _child = parent.children[i];
    if (_child === child) {
      return true;
    }
  }
};
var setDefaultOptions = function setDefaultOptions(largeFileUploaderOptions) {
  var defaultOptions = {
    slice: true,
    sliceSize: 100000,
    minSlicedFileSize: 1000000,
    numberOfChunks: 1,
    retryCountLimit: 3,
    multiple: true,
    accept: "",
    offlineStorage: false,
    spaceName: "",
    immediately: true,
    sizeLimit: null,
    numberOfThreads: 3,
    openHash: true,
    maxNumberOfRequest: 6,
    gotCache: function gotCache() {},
    update: function update() {},
    error: function error(_error) {
      console.error("Large-File-Uploader occurred errors, error detail:");
      console.error(_error);
    },
    success: function success() {},
    checkHash: undefined
  };
  return _objectSpread(_objectSpread({}, defaultOptions), largeFileUploaderOptions);
};
var _uploadFile = function uploadFile(newestUploadDataList, largeFileUploaderOptions, uploadPromiseResolve, uploadPromiseReject) {
  var options = setDefaultOptions(largeFileUploaderOptions);
  var body = document.body;
  var createInput = createHiddenUploaderInputOrCreateDirectlyUpload();
  var input = createInput(options, newestUploadDataList, uploadPromiseResolve, uploadPromiseReject);
  if (!include(body, input)) {
    document.body.appendChild(input);
  }
  input.click();
};
var getOfflineFiles = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(currentUploadList, _ref6) {
    var spaceName, files, fileCacheCount, currentUploadListLength, i;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            spaceName = _ref6.spaceName;
            _context4.next = 3;
            return db.files.where("spaceName").equals(spaceName).toArray();
          case 3:
            files = _context4.sent;
            fileCacheCount = files.length;
            currentUploadListLength = currentUploadList.length;
            if (fileCacheCount && currentUploadListLength) {
              for (i = currentUploadListLength - 1; i >= 0; i--) {
                currentUploadList[i + fileCacheCount] = currentUploadList[i];
              }
            }
            return _context4.abrupt("return", files.map(function (fileObject, index) {
              currentUploadList[index] = {
                status: "suspended",
                progress: fileObject.start / fileObject.chunks.length,
                isCache: true,
                file: fileObject.file,
                result: null,
                createTimestamp: fileObject.createTimestamp,
                total: fileObject.chunks.length
              };
              return {
                name: fileObject.file.name,
                file: fileObject.file,
                status: "suspended",
                progress: fileObject.start / fileObject.chunks.length,
                result: null,
                createTimestamp: fileObject.createTimestamp,
                total: fileObject.chunks.length,
                fileObject: fileObject
              };
            }));
          case 8:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return function getOfflineFiles(_x7, _x8) {
    return _ref7.apply(this, arguments);
  };
}();
var createFileUploader = function createFileUploader(largeFileUploaderOptions) {
  var options = setDefaultOptions(largeFileUploaderOptions);
  var currentUploadList = [];
  var storagePromiseResolve, storagePromiseReject;
  var storagePromise = new Promise(function (resolve, reject) {
    storagePromiseResolve = resolve;
    storagePromiseReject = reject;
  });
  var uploadPromiseResolve, uploadPromiseReject;
  var uploadPromise = new Promise(function (resolve, reject) {
    uploadPromiseResolve = resolve;
    uploadPromiseReject = reject;
  });
  Promise.all([storagePromise, uploadPromise]).then(function () {
    options.success({
      result: true,
      data: currentUploadList
    });
  }).catch(function (error) {
    options.error(error);
  });
  if (options.offlineStorage) {
    getOfflineFiles(currentUploadList, options).then(function (uploadDataListInStorage) {
      var currentNumberOfRequestRef = {
        current: 0
      };
      var promise = Promise.all(uploadDataListInStorage.map(function (uploadData, index) {
        return new Promise(function (resolve, reject) {
          var suspendedRef = {
            current: false
          };
          var canceledRef = {
            current: false
          };
          var sliceStartRef = {
            current: uploadData.fileObject.start
          };
          var _retryCountRef = {
            current: 0
          };
          var customParamsRef = {
            current: uploadData.fileObject.customParams
          };
          var currentUploadListRef = {
            current: currentUploadList
          };
          var updateUploadDataList = function updateUploadDataList(index, progressData) {
            currentUploadList[index] = _objectSpread(_objectSpread({}, currentUploadList[index]), progressData);
            return currentUploadList;
          };
          var computeProgress = function computeProgress(start) {
            return start / uploadData.fileObject.chunks.length;
          };
          var pause = function pause() {
            suspendedRef.current = true;
            if (currentUploadList[index].status === "uploading") {
              currentNumberOfRequestRef.current--;
              updateUploadDataList(index, {
                status: "suspended",
                progress: computeProgress(sliceStartRef.current)
              });
              options.update(computeUploadDataList(currentUploadList));
              var uploader = findFirstWaiting(currentUploadListRef.current);
              if (uploader) {
                uploader.resume();
              }
              db.files.update(uploadData.fileObject.id, {
                status: "suspended",
                start: sliceStartRef.current,
                end: sliceStartRef.current + options.numberOfChunks
              });
            }
          };
          var resume = function resume() {
            if (currentUploadList[index].status === "initialization" || currentUploadList[index].status === "suspended" || currentUploadList[index].status === "failure") {
              _retryCountRef.current = 0;
              suspendedRef.current = false;
              var start = sliceStartRef.current;
              autoUpload(start, {
                idRef: {
                  current: uploadData.fileObject.id
                },
                upload: options.upload,
                updateUploadDataList: updateUploadDataList,
                computeProgress: computeProgress,
                update: options.update,
                resolve: resolve,
                reject: reject,
                sliceStartRef: sliceStartRef,
                length: uploadData.fileObject.chunks.length,
                index: index,
                numberOfChunks: options.numberOfChunks,
                chunks: uploadData.fileObject.chunks,
                customParamsRef: customParamsRef,
                retryCountLimit: options.retryCountLimit,
                _retryCountRef: _retryCountRef,
                suspendedRef: suspendedRef,
                canceledRef: canceledRef,
                currentUploadListRef: currentUploadListRef,
                offlineStorage: options.offlineStorage,
                spaceName: options.spaceName,
                file: uploadData.fileObject.file,
                hashSum: uploadData.fileObject.hashSum,
                currentNumberOfRequestRef: currentNumberOfRequestRef,
                maxNumberOfRequest: options.maxNumberOfRequest
              }, true);
            }
          };
          var remove = function remove() {
            currentNumberOfRequestRef.current--;
            canceledRef.current = true;
            currentUploadList[index].status = "cancel";
            options.update(computeUploadDataList(currentUploadList));
            db.files.delete(uploadData.fileObject.id);
            resolve(true);
          };
          currentUploadList[index].pause = pause;
          currentUploadList[index].resume = resume;
          currentUploadList[index].remove = remove;
        });
      }));
      options.gotCache(currentUploadList.slice(0, uploadDataListInStorage.length), currentUploadList);
      options.update(computeUploadDataList(currentUploadList));
      return promise;
    }).then(function () {
      storagePromiseResolve();
    }).catch(function (error) {
      storagePromiseReject(error);
    });
  } else {
    // @ts-ignore
    storagePromiseResolve();
  }
  return {
    uploadFile: function uploadFile() {
      return _uploadFile(currentUploadList, largeFileUploaderOptions, uploadPromiseResolve, uploadPromiseReject);
    },
    giveFilesToUpload: function giveFilesToUpload(files) {
      var uploadDirectly = createHiddenUploaderInputOrCreateDirectlyUpload(files);
      uploadDirectly(options, currentUploadList, uploadPromiseResolve, uploadPromiseReject);
    }
  };
};

export { createFileUploader as default };
